\chapter{The Classification using the Segmentation Maps}

\begin{spacing}{1.2}

\section{Global Idea}

The idea is described in figure 5.1. The input of our neural network is the image. It first passes through the segmentation network we saw before (a UNet model that trains on 600 epochs on the segmentation of all labels). Then the obtained segmentation maps are passed through the classification. The classification can be a simple threshold or another neural network. Finally, it outputs the prediction: whether the patient is pathological or not. 

\begin{figure}[!h]
\begin{center}
\includegraphics[height=5cm]{classificationSegmentation/schema.png}
\end{center}
\caption{Schema of the classifier}
\end{figure}


\section{Classification with a threshold on the ratio}

\subsection*{Description of the method}

The first idea is to simply classify by using a threshold on the ratio. 
The ratio is defined as the volume of the damaged heart divided by the volume of the total heart (see eq. 5.1).

\begin{equation}
ratio = \frac{V_{myocardial-infarction} + V_{no-reflow-area}}{V_{cavity} + V_{myocardium} + V_{myocardial-infarction} + V_{no-reflow-area}}
\end{equation}
~\\
To decide on the value of the threshold, I decided to display the ratio for pathological and for non-pathological patients (see fig. 5.2). The ratio displayed are those from the validation dataset in order to not influence the results of the test. I decided to use 0.02 as a threshold as there seems to be a separation at this value between pathological and non-pathological patients. 

\begin{figure}[!h]
\begin{center}
\includegraphics[height=9cm]{classificationSegmentation/threshold/ratio_val.png}
\end{center}
\caption{Ratio for pathological and non pathological patients}
\end{figure}

\subsection*{Results}
With a threshold of 0.02 on the testing dataset, we obtain an accuracy of 0.92 which is a really good score (see. fig 5.3). The classifier works well. 

\begin{figure}[!h]
\begin{center}
\includegraphics[height=8cm]{classificationSegmentation/threshold/confusion_matrix (1).png}
\end{center}
\caption{Confusion Matrix}
\end{figure}

\section{Classification with logistic regression on the ratio}

\subsection*{Description of the trainer}
Instead of choosing manually the threshold, this time we use a neural network to predict thanks to the ratio. 
First, it manually computes the ratio (with the equation 5.1), then the ratio is passed through a Linear Layer (with one feature input and one feature output), and finally, the output from the Linear Layer is passed through a sigmoid (to ensure the output of the neural network is between 0 and 1). 
The succession of a linear layer with a sigmoid is called a logistic regression. 

A Linear Layer applies a linear transformation to the incoming data: $y = xA^T + b$. The size of A depends on the number of in and out features. 

The loss used for this trainer is the same as for the classification with a DenseNet model: the Binary Cross Entropy Loss. The training is done on 600 epochs. It took 3.6 hours (without the training on the segmentation). 

\subsection*{Results}
The accuracy obtained, with a threshold of 0.5 on the confusion matrix, is 0.65. It is less than the previous accuracy found with only a DenseNet network. Moreover, the area under the roc curve is 0.55, which is close to 0.5 (the value for a random classifier).

The results are inferior to those obtained with a simple threshold or with a DenseNet neural network, and are similar to those of a random classifier.

\begin{figure}[!h]
\begin{center}
\includegraphics[height=8cm]{classificationSegmentation/confusion_matrix(hybrid_ratio).png}
\end{center}
\caption{Confusion Matrix obtained with a logistic regression on the ratio}
\end{figure}

\begin{figure}[!h]
\begin{center}
\includegraphics[height=9cm]{classificationSegmentation/roc_curve(ratio).png}
\end{center}
\caption{The ROC Curve obtained with a logistic regression on the ratio}
\end{figure}

\newpage
\section{Classification with a logistic regression on the volumes}

\subsection*{Description of the trainer}
The last idea is to let the neural network be more autonomous. Instead of doing a logistic regression on a ratio computed manually, the logistic regression is done on the 4 volumes of the heart. 
First, we compute the volume for each class except the background (myocardium, cavity, myocardial infarction, and no-reflow area). Then those four volumes are passed through a Linear Layer (with 4 in-features and 1 out-features), and its output is passed through the sigmoid function to obtain the prediction. 

This trainer also uses the Binary Cross Entropy Loss and is trained during 600 epochs. It took 3.7 hours (without the training on the segmentation).

\subsection*{The results}
With a threshold of 0.5, the accuracy obtained on the confusion matrix is 0.9 (see fig. 5.6). Only two patients are misclassified. Moreover, the AUROC is also high, as its value is 0.98 (see fig. 5.7). 

This classifier is the one that provides the best results. It is close to a perfect classifier. 

\begin{figure}[!h]
\begin{center}
\includegraphics[height=9cm]{classificationSegmentation/confusion_matrix(volume).png}
\end{center}
\caption{Confusion Matrix obtained with a logistic regression on the volumes}
\end{figure}

\begin{figure}[!h]
\begin{center}
\includegraphics[height=9cm]{classificationSegmentation/roc_curve(volume).png}
\end{center}
\caption{The ROC Curve obtained with a logistic regression on the volumes}
\end{figure}

\end{spacing}